.TH fileutil 1 "06 Jun 94" "shaw" "rocat manual"
.IX fileutil
.SH NAME
fileutil - upload/download files area maintenance utility 
.SH SYNOPSIS
.B fileutil
.RB [ -c section_name ]
.RB [ -n output_filename ]
.RB [ -m output_filename  ]
.RB [ -u ]
.RB [ -d ]
.SH DESCRIPTION
Automated file utility for files areas maintenance.

.I fileutil 
will create, update, clean and generate reports based on file section(s)
used by the rocat BBS system.

.I fileutil 
will print a usage listing if used without options (or incorrect options)

.SH OPTIONS
.TP
.B -c section_name
Tells
.I fileutil
to create the section 
.B section_name
The section information must already exist in the bbs_files_header file.  
It will read the directory associated with the files section and build a 
section header file based on the files found there.  

.B Note:
This command is for new section creation only.  Any existing files section
header will be discarded, resulting in lost header information.

.TP
.B -n output_filename
Will generate a report of the new files uploaded within the last 7 days.

.TP
.B -m output_filename
Will generate a report of the top 20 files by number of downloads.

.TP
.B -u 
Update all files sections.  This will add files found in each files section
directory.   This is a safer, global version of the '-c' option.

.TP
.B -d 
Delete files that exist in the files section header, but do not exist in
the files section directory.

.SH BUGS
.I fileutil
logs all errors to the BBS errlogd logging daemon.  Error messages don't
show up locally.

.SH "SEE ALSO"
errlogd(1),  rocat(1), rocat documentation
.SH AUTHOR
.I fileutil
is Copyright (C) 1994 by Gregory Shaw, <shaw@manwe.fmsoft.com>.
